/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.sql.*;
import COM.Sun.Japan.yjs.mwt.*;

/**
 * hello(konnichiha) e[upeiXEAvP[V
 * @author Yuichi Omata, Nihon Sun Microsystems K.K.
 * @version 1.2 97/01/21
 */
public class ImageStore {

    // GUI i
    ImageStoreGUI gui;
    Login loginDialog;

    // t@CE_CAOƑO񃍁[h̏̋L
    FileDialog loadDialog;
    String fileDir = null;
    FilenameFilter filter = null;

    // f[^x[Xڑp
    String table;
    Connection conn;
    // C[W
    private final int MAX_BYTES_OF_IMAGE = 8192;
    byte[] imageBuff = new byte[MAX_BYTES_OF_IMAGE];
    int imageLen;

    /**
     * RXgN^
     */
    public ImageStore() {
        // gpe[ům ("hello.table" vpeBgp)
        // ex:
        //   java -Dhello.table=konnichiha ImageStore
        table = (String)System.getProperties().get("hello.table");
        if (table == null) table = "hello";

        // GUI ̏
	gui =  new ImageStoreGUI(this);
	modeSelect();
        loginDialog = new Login(gui);

        // ڑ̊m
        conn = loginDialog.getConnection();
        // DriverManager.setLogStream(System.err); // For debug

	gui.setVisible(true);
    }

    /**
     * C֐({̂̏)
     */
    public static void main(String[] args){

	new ImageStore();
	return;
    }

    /**
     * ڑj[̃R[obN֐
     */
    public void connect() {
        loginDialog.setVisible(true);
        conn = loginDialog.getConnection();
    }

    /**
     * Ij[̃R[obN֐
     */
    public void quit() {
       try {
            conn.close();
	} catch (SQLException ex) {}
        System.exit(0);
    }

    /**
     * [hĨR[obN֐
     */
    public void modeSelect() {
        // [hɂ킹Ďs{^̃xύX
        String label = gui.execSelection.getSelectedLabel();
        gui.execButton.setLabel(label);

        // [hɂ킹 GUI ԂύX
        if (label.equals(ExecSelection.SEARCH)) {
            gui.ageField.setEditable(false);
            gui.birthField.setEditable(false);
            gui.commentField.setEditable(false);
        } else if (label.equals(ExecSelection.UPDATE)) {
            gui.ageField.setEditable(true);
            gui.birthField.setEditable(true);
            gui.commentField.setEditable(true);
        } else if (label.equals(ExecSelection.INSERT)) {
            gui.nameField.setText("");
            gui.ageField.setText("");
            gui.ageField.setEditable(true);
            gui.birthField.setText("");
            gui.birthField.setEditable(true);
            gui.commentField.setText("");
            gui.commentField.setEditable(true);
        } else if (label.equals(ExecSelection.DELETE)) {
            gui.ageField.setText("");
            gui.ageField.setEditable(false);
            gui.birthField.setText("");
            gui.birthField.setEditable(false);
            gui.commentField.setText("");
            gui.commentField.setEditable(false);
	}
    }

    /**
     * s{^̃R[obN֐
     */
    public void exec(String mode) {
        if (mode.equals(ExecSelection.SEARCH))
	    search();
        else if (mode.equals(ExecSelection.UPDATE))
	    update();
        else if (mode.equals(ExecSelection.INSERT))
            insert();
        else if (mode.equals(ExecSelection.DELETE))
            delete();
    }

    /**
     * ̎s
     */
    public void search() {

        try {
            // Xe[gg̍쐬
            Statement stmt = conn.createStatement();

            // ₢킹̎s
            ResultSet rs = stmt.executeQuery(
                "SELECT * FROM " + table + 
                " WHERE name = '" + gui.nameField.getText() + "'");

            int rowCount = 0;
            while (rs.next()) {
                // sf[^̎擾
                rowCount++;
                gui.ageField.setText(rs.getString("age"));
                gui.birthField.setText(rs.getDate("birth_date").toString());
                gui.commentField.setText(rs.getString("comment"));
                // 摜f[^̎擾
                InputStream bs = rs.getBinaryStream("face");
                int size;
                imageLen = 0;
                while ((size = 
                    // JDBC-ODBC ubWł
                    // InputStream.read(byte[], int, int) ĂȂ
                    // ߁Aread(byte[]) őpB
                    // {͑O҂gpB
                    bs.read(imageBuff)) != -1) {
                    imageLen += size;
                }

                // 擾摜f[^ Image IuWFNg쐬
                Image img = gui.getToolkit().createImage(
                    new sun.awt.image.ByteArrayImageSource(
                        imageBuff, 0, imageLen));

                MediaTracker tracker = new MediaTracker(gui);
                tracker.addImage(img, 0);
                try {
                    tracker.waitForID(0);
                } catch (InterruptedException ex) {}
                
                if (img.getWidth(gui.faceCanvas) == -1) {
                    gui.faceCanvas.setImage(gui.noFace);
                    imageLen = 0;
                } else
                    gui.faceCanvas.setImage(img);
            }
            if (rowCount == 0)
                new MessageDialog("f[^܂B", gui);

            // Xe[gg̉
            rs.close();
            stmt.close();

        } catch (SQLException ex) {
            new MessageDialog("SQLException", gui);
            ex.printStackTrace();
        } catch (IOException ex) {
            new MessageDialog("IOException", gui);
            ex.printStackTrace();
        }

    }

    /**
     * XV̎s
     */
    public void update() {
        try {
            // XV SQL ̍쐬
            PreparedStatement stmt = conn.prepareStatement(
            "UPDATE " + table +
            " SET age = ?,birth_date = ?,comment = ?,face = ? WHERE name = ?");

            // eJf[^̐ݒ
            stmt.setInt(1, Integer.valueOf(gui.ageField.getText()).intValue());
            stmt.setDate(2, java.sql.Date.valueOf(gui.birthField.getText()));
            stmt.setString(3, gui.commentField.getText());
            stmt.setBinaryStream(
                4, new ByteArrayInputStream(imageBuff), imageLen);
            stmt.setString(5, gui.nameField.getText());

            // XV̎s
            if (stmt.executeUpdate() < 1)
                new MessageDialog("XVɎs܂B", gui);
            stmt.close();
            
        } catch (SQLException ex) {
            new MessageDialog("SQLException", gui);
            ex.printStackTrace();
        }
    }

    /**
     * VKf[^̑}
     */
    public void insert() {
        try {
            // } SQL ̍쐬
            PreparedStatement stmt = conn.prepareStatement(
                "INSERT INTO " + table + " VALUES (?, ?, ?, ?, ?)");

            // eJf[^̐ݒ
            stmt.setString(1, gui.nameField.getText());
            stmt.setInt(2, Integer.valueOf(gui.ageField.getText()).intValue());
            stmt.setDate(3, java.sql.Date.valueOf(gui.birthField.getText()));
            stmt.setString(4, gui.commentField.getText());
            stmt.setBinaryStream(
                5, new ByteArrayInputStream(imageBuff), imageLen);

            // }̎s
            if (stmt.executeUpdate() < 1)
                new MessageDialog("VKf[^쐬ł܂B", gui);
            stmt.close();

        } catch (SQLException ex) {
            new MessageDialog("SQLException", gui);
            ex.printStackTrace();
        }
    }

    /**
     * f[^̍폜
     */
    public void delete() {
        try {
            // 폜 SQL ̍쐬
            PreparedStatement stmt = conn.prepareStatement(
                "DELETE FROM " + table + " WHERE name = ?");

            // Jf[^̐ݒ
            stmt.setString(1, gui.nameField.getText());

            // 폜̎s
            if (stmt.executeUpdate() < 1)
                new MessageDialog("OsłB", gui);
            stmt.close();

        } catch (SQLException ex) {
            new MessageDialog("SQLException", gui);
            ex.printStackTrace();
        }
    }

    /**
     * 摜f[^̃t@C̃[h
     */
    public void loadImage() {

        // t@CE_CAO̕\
        loadDialog = new FileDialog(gui, "ʐ^̓ǂݍ", FileDialog.LOAD);

        if (fileDir != null) 
            loadDialog.setDirectory(fileDir);
        if (filter != null)
            loadDialog.setFilenameFilter(filter);
	loadDialog.setVisible(true);

	String file = loadDialog.getFile();
	
        // LZ
	if (file == null || file.equals("")) {
            fileDir = loadDialog.getDirectory();
            filter = loadDialog.getFilenameFilter();
	    return;
        }

        try {
            // 摜t@C̃[h
            FileInputStream fis = new FileInputStream(loadDialog.getDirectory() + loadDialog.getFile());
            int size;
            imageLen = 0;
            while ((size = fis.read(imageBuff)) != -1) {
                imageLen += size;
            }
        } catch (IOException ex) {
            new MessageDialog("IOException", gui);
            ex.printStackTrace();
        }
        
        // 摜t@CC[W̍쐬
        Image img = gui.createImage(new sun.awt.image.ByteArrayImageSource(imageBuff, 0, imageLen));
	MediaTracker tracker = new MediaTracker(gui.faceCanvas);
	tracker.addImage(img, 0);

	try {
	    tracker.waitForID(0);
	    if (img.getWidth(gui.faceCanvas) == -1) {
                new MessageDialog("摜t@CsłB", gui);
                gui.faceCanvas.setImage(gui.noFace);
                imageLen = 0;
            } else {
                gui.faceCanvas.setImage(img);
            }
	} catch (InterruptedException ex) {
	    gui.faceCanvas.setImage(gui.noFace);
            imageLen = 0;
	}
        // _CAO̍XV
        fileDir = loadDialog.getDirectory();
        filter = loadDialog.getFilenameFilter();
    }
}
