/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import COM.Sun.Japan.yjs.mwt.*;

/**
 * ImageStore  GUI
 * @author Yuichi Omata, Nihon Sun Microsystems K.K.
 * @version 1.1 97/01/21
 */
public class ImageStoreGUI extends Frame implements WindowListener {

    ImageStore imageStore;
    Label nameLabel;
    TextField nameField;
    Label ageLabel;
    TextField ageField;
    Label birthLabel;
    TextField birthField;
    Label commentLabel;
    TextField commentField;
    SimpleImageCanvas faceCanvas;
    ExecSelection execSelection;
    Button execButton;
    Button loadButton;

    MenuBar menuBar;
    Menu connectMenu;
    MenuItem connectMenuConnect;
    MenuItem connectMenuQuit;

    Image noFace;


    public ImageStoreGUI(ImageStore imageStore) {
	addNotify();
	setTitle("ImageStore");
        addWindowListener(this);

	this.imageStore = imageStore;

	MediaTracker tracker = new MediaTracker(this);
	noFace = createImage(80, 100);
	tracker.addImage(noFace, 0);
	try {
	    tracker.waitForID(0);
	} catch (InterruptedException ex) {}
	Graphics g = noFace.getGraphics();
	g.setColor(Color.black);
	g.fillRect(0, 0, 80, 100);
	g.setColor(Color.white);
	g.setFont(new Font("Dialog", Font.PLAIN, 12));
	g.drawString("No Image", 10, 56);

	GridBagLayout gbl = new GridBagLayout();
	gbl.columnWidths = new int[] {14,14,14,14,14,14};
	gbl.rowHeights =  new int[] {14,14,14,14,14,14,14,14,14,14,14};
	gbl.columnWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0};
	gbl.rowWeights =
            new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	setLayout(gbl);
	GridBagConstraints gbc = new GridBagConstraints();

	// Ox̍쐬
	nameLabel = new Label("O:");
	gbc.gridx = 1;
	gbc.gridy = 1;
	gbc.anchor = GridBagConstraints.EAST;
	gbl.setConstraints(nameLabel, gbc);
	add(nameLabel);

	// OtB[h̍쐬
	nameField = new TextField(12);
	gbc.gridx++;
	gbc.anchor = GridBagConstraints.WEST;
	gbl.setConstraints(nameField, gbc);
	add(nameField);

	// Nx̍쐬
	ageLabel = new Label("N:");
	gbc.gridx = 1;
	gbc.gridy += 2;
	gbc.anchor = GridBagConstraints.EAST;
	gbl.setConstraints(ageLabel, gbc);
	add(ageLabel);
	
	// NtB[h̍쐬
	ageField = new TextField(2);
	gbc.gridx++;
	gbc.anchor = GridBagConstraints.WEST;
	gbl.setConstraints(ageField, gbc);
	add(ageField);

	// ax̍쐬
	birthLabel = new Label("a:");
	gbc.gridx = 1;
	gbc.gridy += 2;
	gbc.anchor = GridBagConstraints.EAST;
	gbl.setConstraints(birthLabel, gbc);
	add(birthLabel);

	// atB[h̍쐬
	birthField = new TextField(12);
	gbc.gridx++;
	gbc.anchor = GridBagConstraints.WEST;
	gbl.setConstraints(birthField, gbc);
	add(birthField);

	// Rgx̍쐬
	commentLabel = new Label("Rg:");
	gbc.gridx = 1;
	gbc.gridy += 2;
	gbc.anchor = GridBagConstraints.EAST;
	gbl.setConstraints(commentLabel, gbc);
	add(commentLabel);

	// RgtB[h̍쐬
	commentField = new TextField(30);
	gbc.gridx++;
	gbc.gridwidth = 3;
	gbc.anchor = GridBagConstraints.WEST;
	gbl.setConstraints(commentField, gbc);
	add(commentField);
	
	// I{^̍쐬
	execSelection = new ExecSelection();
	gbc.gridx = 1;
	gbc.gridy += 2;
	gbc.gridwidth = 1;
	gbl.setConstraints(execSelection, gbc);
	add(execSelection);
	execSelection.addActionListener(new ImageStoreCommand(ImageStoreCommand.Select, imageStore));	

	// s{^̍쐬
	execButton = new Button("");
	gbc.gridx++;
	gbc.anchor = GridBagConstraints.CENTER;
	gbl.setConstraints(execButton, gbc);
	execButton.addActionListener(new ImageStoreCommand(ImageStoreCommand.Exec, imageStore));	
	add(execButton);

	// 摜[h{^̍쐬
	loadButton = new Button("摜[h...");
	gbc.gridx++;
	gbc.gridwidth = 2;
	gbl.setConstraints(loadButton, gbc);
	loadButton.addActionListener(new ImageStoreCommand(ImageStoreCommand.Load, imageStore));	
	add(loadButton);

        // ʐ^\pLoX̍쐬
	faceCanvas = new SimpleImageCanvas();
	faceCanvas.setSize(80, 100);
	faceCanvas.setImage(noFace);
	gbc.gridx = 4;
	gbc.gridy = 1;
	gbc.gridwidth = 1;
	gbc.gridheight = 5;
	gbl.setConstraints(faceCanvas, gbc);
	add(faceCanvas);

        // j[̒ǉ
        menuBar = new MenuBar();
        connectMenu = new Menu("ڑ");
        connectMenuConnect = new MenuItem("ڑ...");
        connectMenuConnect.addActionListener(new ImageStoreCommand(ImageStoreCommand.Connect, imageStore));
        connectMenu.add(connectMenuConnect);
        connectMenuQuit = new MenuItem("I");
        connectMenuQuit.addActionListener(new ImageStoreCommand(ImageStoreCommand.Quit, imageStore));
        connectMenu.add(connectMenuQuit);
        menuBar.add(connectMenu);
        setMenuBar(menuBar);

	pack();
    }

    /**
     * EBhEECxg̏
     */
    public void windowClosing(WindowEvent ev){
        imageStore.quit();
    }

    public void windowClosed(WindowEvent ev){}
    public void windowDeiconified(WindowEvent ev){}
    public void windowIconified(WindowEvent ev){}
    public void windowOpened(WindowEvent ev){}
}

