/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
*
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.SQLException;
import COM.Sun.Japan.yjs.mwt.Selection;
import COM.Sun.Japan.yjs.mwt.MessageDialog;


/**
 * ėpf[^x[XEANZXEAvP[VB
 *
 * @version     1.1 97/01/09
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public final class DatabaseBrowser extends Frame implements ActionListener {
    /**
     * f[^x[XEIuWFNg\邽߂̃r[B
     */
    DatabaseObjectView objectView;

    /**
     * f[^x[Xւ̐ڑOCE_CAOB
     */
    Login login;

    /**
     * j[Eo[B
     */
    MenuBar menuBar;

    /**
     * "Database" j[
     */
    Menu dbMenu;
    MenuItem dbOpen;
    MenuItem dbClose;
    MenuItem exit;

    /**
     * ftHgERXgN^B
     */
    public DatabaseBrowser() {
        objectView = new DatabaseObjectView(null, 1000, 700);
        objectView.setCanvasBackground(Color.white);
        setTitle("Database Browser : [unconnected]");
        setLayout(new BorderLayout());
        add("Center", objectView);
        // j[o[̍쐬
        menuBar = new MenuBar();
        dbMenu = new Menu("Database");
        dbMenu.add(dbOpen = new MenuItem("Open..."));
        dbMenu.add(dbClose = new MenuItem("Close"));
        dbMenu.addSeparator();
        dbMenu.add(exit = new MenuItem("Exit"));
        menuBar.add(dbMenu);
        setMenuBar(menuBar);
        //
        dbOpen.addActionListener(this);
        dbClose.addActionListener(this);
        exit.addActionListener(this);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        setSize(700, 550);
    }

    /**
     * j[ action performed Cxg̃nhOB
     * @param ev CxgB
     */
    public void actionPerformed(ActionEvent ev) {
        if (ev.getSource() == dbOpen) {
            initGUI();
            login = new Login(this);
            setConnection(login.getConnection());
        } else if (ev.getSource() == dbClose) {
            initGUI();
            objectView.setConnection(null);
        } else if (ev.getSource() == exit) {
            initGUI();
            System.exit(0);
        }
    }

    /**
     * {AvP[VŜANeBu/ANeBuB
     * @param f tO
     */
    public void setEnabled(boolean f) {
        super.setEnabled(f);
        objectView.setEnabled(f);
    }

    /**
     * window Cxg̃nhOB
     * @param ev CxgB
     */
    protected void processWindowEvent(WindowEvent ev) {
        if (ev.getId() == WindowEvent.WINDOW_CLOSING) {
            System.exit(1);
        } else {
            super.processWindowEvent(ev);
        }
    }

    /**
     * f[^x[Xڑ̃ZbgB
     * @param conn RlNV
     */
    void setConnection(Connection conn) {
        DatabaseMetaData dmd;
        StringBuffer url = new StringBuffer("[connecting to ");

        objectView.setConnection(conn);
        if (conn == null) {
            setTitle("Database Browser : [unconnected]");
            return;
        }
        // ڑĂf[^x[X URL l
        try {
            dmd = conn.getMetaData();
            url.append(dmd.getURL());
        } catch (SQLException ex) {
            new MessageDialog(ex, this);
        }
        url.append("]");
        //
        setTitle("Database Browser : " + url.toString());
    }

    /**
     * GUI ̏B
     */
    void initGUI() {
        if (login != null) {
            login.hide();
            login = null;
        }
        setConnection(null);
    }

    /**
     * AvP[VNp main \bhB
     */
    public static void main(String[] a) {
        DatabaseBrowser  browser;
        browser = new DatabaseBrowser();
        browser.show();
    }
}

