/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.util.Vector;
import java.util.Enumeration;
import COM.Sun.Japan.yjs.mwt.ScrollableCanvas;

/**
 * DatabaseObject NXpăIuWFNg̃ACR\
 * sLoXBXN[o[ĂB
 *
 * @version     1.2 97/01/23
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class DatabaseObjectCanvas extends ScrollableCanvas implements MouseListener {
    /**
     * IuWFNg̃Xg
     */
    Vector objectList;

    /**
     * IĂIuWFNg̃CfbNXBI
     * IuWFNgȂ -1B
     */
    protected int selectedIndex;

    /**
     * IꂽIuWFNg\킷}[N̐FB
     */
    Color selectedColor;

    /**
     * eIuWFNg̊Ԃ̗]B
     */
    Insets objectInsets;

    /**
     * ftHgERXgN^B
     */
    public DatabaseObjectCanvas() {
        this(null, -1, -1);
    }

    /**
     * IuWFNg̃XgɎRXgN^B
     * @param list IuWFNg̃Xg
     */
    public DatabaseObjectCanvas(Vector list) {
        this(list, -1, -1);
    }

    /**
     * IuWFNg̃XgƁALoX̕`ɎgpItEXN[
     * ̕AɎRXgN^B
     * @param list IuWFNg̃Xg
     * @param width ItEXN[̕
     * @param height ItEXN[̍
     */
    public DatabaseObjectCanvas(Vector list, int width, int height) {
        super(width, height);
        selectedIndex = -1;
        selectedColor = new Color(200, 200, 200);
        screen.setFont(new Font("Courier", Font.BOLD, 11));
        addMouseListener(this);
        objectInsets = new Insets(7, 7, 17, 7);
        setObjectList(list);
     }

    /**
     * DatabaseObjectCanvas ̕`B
     * @param g Graphics
     */
    public void paint(Graphics g) {
        super.paint(g);
        drawObjects();
    }

    /**
     * IuWFNg̃Xg̃ZbgB
     * @param list
     */
    public synchronized void setObjectList(Vector list) {
        objectList = list;
        relocateObject();
        drawObjects();
    }

    /**
     * ݂̃IuWFNg̃XgԂB
     */
    public Vector getObjectList() {
        return objectList;
    }

    /**
     * IuWFNg̔zusBł́AeIuWFNg̈ʒuς
     * ݂̂ŃLoXւ̕`͍sȂB
     */
    public void relocateObject() {
        Enumeration en;
        int x, y;
        int w, h;
        int xm, ym;
        int ymax;
        DatabaseObject dbo;
        if (objectList == null)
            return;
        x = objectInsets.left * 2;
        y = objectInsets.top * 2;
        xm = objectInsets.left + objectInsets.right;
        ym = objectInsets.top + objectInsets.bottom;
        ymax = 0;
        for (en = objectList.elements(); en.hasMoreElements();) {
            dbo = (DatabaseObject)(en.nextElement());
            w = dbo.getSize().width;
            h = dbo.getSize().height;
            ymax = Math.max(ymax, h);
            if (x + w + xm > getScreenSize().width) {
                x = objectInsets.left * 2;
                y = y + ymax + ym;
                ymax = 0;
            }
            dbo.setLocation(x, y);
            x = x + w + xm;
        }
        selectedIndex = -1;
    }

    /**
     * SẴIuWFNg`悷B
     */
    public void drawObjects() {
        Graphics g = screen.getBufferGraphics();
        if (g == null)
            return;
        //
        g.setColor(screen.getBackground());
        g.fillRect(0, 0, getScreenSize().width, getScreenSize().height);
        if (objectList == null)
            return;
        for (Enumeration en = objectList.elements(); en.hasMoreElements();) {
            drawObject((DatabaseObject)en.nextElement());
        }
    }
        
    /**
     * DatabaseObject ɎÃIuWFNg`悷B
     * @param dbo `悷 DatabaseObject
     */
    public void drawObject(DatabaseObject dbo) {
        Graphics g = screen.getBufferGraphics();
        if (g == null || dbo == null)
            return;
        //
        FontMetrics fm;
        int x, y;
        int w, h;
        int lx, ly;
        char[] nc;
        int index = objectList.indexOf(dbo);
        fm = g.getFontMetrics();
        x = dbo.getLocation().x;
        y = dbo.getLocation().y;
        w = dbo.getSize().width;
        h = dbo.getSize().height;
        nc = dbo.getName().toCharArray();
        lx = x + w / 2 - fm.charsWidth(nc, 0, nc.length) / 2;
        ly = y + h + objectInsets.bottom / 2;
        if (index == selectedIndex) {
            g.setColor(selectedColor);
        } else {
            g.setColor(screen.getBackground());
        }
        g.fillRect(x - objectInsets.left,
                   y - objectInsets.top,
                   w + objectInsets.left + objectInsets.right,
                   h + objectInsets.top + objectInsets.bottom);
        g.drawImage(dbo.getObjectImage(), x, y, this);
        g.setColor(screen.getForeground());
        g.drawString(dbo.getName(), lx, ly);
    }

    /**
     * CfbNXɎA̒lIuWFNgIԂ
     * B
     * @param index object index
     */
    public void selectObject(int index) {
        if (objectList == null || index < 0 || index >= objectList.size())
            return;
        selectedIndex = (selectedIndex == index) ? -1 : index;
    }

    /**
     * IԂɂIuWFNgԂB
     * @return IĂȂ΁A null ԂB
     */
    public DatabaseObject selectedObject() {
        if (objectList == null || selectedIndex < 0)
            return null;
        return (DatabaseObject)(objectList.elementAt(selectedIndex));
    }

    /**
     * IԂɂIuWFNg̃CfbNXԂB
     * @return IĂȂ΁A -1 ԂB
     */
    public int selectedObjectIndex() {
        return selectedIndex;
    }

    /**
     * LoXŔ mouse clicked Cxg̃nhB
     * @param ev  mouse CxgB
     */
    public void mouseClicked(MouseEvent ev) {
        Enumeration en;
        DatabaseObject dbo = null;
        int oix, oldOix;
        boolean f = false;
        if (objectList == null)
            return;
        for (en = objectList.elements(); en.hasMoreElements();) {
            dbo = (DatabaseObject)(en.nextElement());
            if (dbo.onObject(ev.getX(), ev.getY())) {
                f = true;
                break;
            }
        }
        if (f) {
            oldOix = selectedIndex;
            oix = objectList.indexOf(dbo);
            switch (ev.getClickCount()) {
            case 2:
                selectedIndex = -1;
                selectObject(oix);
                break;
            case 1:
                selectObject(oix);
                break;
            default:
                selectedIndex = -1;
                break;
            }
            drawObject(dbo);
            if (oldOix != oix && oldOix >= 0)
                drawObject((DatabaseObject)objectList.elementAt(oldOix));
        }
    }

    /**
     * LoXŔ mouse pressed Cxg̃nhOB
     * ۂ́AĂȂB
     * @param ev  mouse CxgB
     */
    public void mousePressed(MouseEvent ev) {}

    /**
     * LoXŔ mouse released Cxg̃nhOB
     * ۂ́AĂȂB
     * @param ev  mouse CxgB
     */
    public void mouseReleased(MouseEvent ev) {}
    /**
     * LoXŔ mouse entered Cxg̃nhOB
     * ۂ́AĂȂB
     * @param ev  mouse CxgB
     */
    public void mouseEntered(MouseEvent ev) {}
    /**
     * LoXŔ mouse Exited Cxg̃nhOB
     * ۂ́AĂȂB
     * @param ev  mouse CxgB
     */
    public void mouseExited(MouseEvent ev) {}
}
