/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.util.Vector;
import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;
import COM.Sun.Japan.yjs.mwt.Selection;
import COM.Sun.Japan.yjs.mwt.MessageDialog;

/**
 * DatabaseObject păNXpăIuWFNg̃ACR\
 * sB\IuWFNg̎ނZNVɂđI邱
 * ƂłB܂IuWFNg̃ACR_uENbN邱
 * ɂAڍ׏\EBhEJB
 *
 * @version     1.1 97/01/09
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class DatabaseObjectView extends Panel implements ActionListener, MouseListener {
    /**
     * IuWFNg̃ACR\LoXB
     */
    DatabaseObjectCanvas objectCanvas;

    /**
     * IuWFNg̎ނIZNVB
     */
    Selection objectTypeSelection;

    /**
     * f[^x[X̃e[u̓e\r[EEBhEB
     */
    TableView tableView;

    /**
     * f[^x[Xւ̃RlNVB
     */
    Connection conn;

    /**
     * f[^x[XEIuWFNg̃XgB
     */
    Vector objectList;
    
    /**
     * ftHgERXgN^B
     */
    public DatabaseObjectView() {
        this(null, -1, -1);
    }

    /**
     * f[^x[Xւ̃RlNVɎRXgN^B
     * @param conn f[^x[Xւ̃RlNVB
     */
    public DatabaseObjectView(Connection conn) {
        this(conn, -1, -1);
    }

    /**
     * f[^x[Xւ̃RlNVƃLoX(ItEXN[)̕
     * ɎRXgN^B
     * @param conn f[^x[Xւ̃RlNVB
     * @param width LoX(ItEXN[)̕B
     * @param height LoX(ItEXN[)̍B
     */
    public DatabaseObjectView(Connection conn, int width, int height) {
        objectCanvas = new DatabaseObjectCanvas(null, width, height);
        //
        String[] sls = {"User Table", "System Table"};
        objectTypeSelection = new Selection("Object Type", sls, Selection.VERTICAL);
        //
        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        setLayout(gbl);
        gbc.anchor = GridBagConstraints.NORTHWEST;
        gbc.fill = GridBagConstraints.NONE;
        gbc.weightx = 0.0;
        gbc.weighty = 1.0;
        gbc.gridwidth = GridBagConstraints.RELATIVE;
        gbl.setConstraints(objectTypeSelection, gbc);
        add(objectTypeSelection);
        gbc.fill = GridBagConstraints.BOTH;
        gbc.weightx = 1.0;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbl.setConstraints(objectCanvas, gbc);
        add(objectCanvas);
        //
        setConnection(conn);
        objectCanvas.addMouseListener(this);
        objectTypeSelection.addActionListener(this);
    }

    /**
     * f[^x[XERlNṼZbgB
     * @param conn f[^x[Xւ̃RlNVB
     */
    public void setConnection(Connection conn) {
        this.conn = conn;
        objectList = null;
        objectCanvas.setObjectList(null);
        //
        if (objectTypeSelection.getFirstSelectedIndex() != -1)
            objectTypeSelection.setButtonStatus(objectTypeSelection.getFirstSelectedIndex(), false);
        hideTableView();
        try {
            if (conn != null && !(conn.isClosed())) {
                objectTypeSelection.setEnabled(true);
            } else {
                objectTypeSelection.setEnabled(false);
            }
        } catch(SQLException ex) {
            objectTypeSelection.setEnabled(false);
            Container c;
            for (c = getParent();
                 c != null && !(c instanceof Frame);
                 c.getParent());
            if (c != null)
                new MessageDialog(ex, (Frame)c);
        }
        if (tableView != null)
            tableView.dispose();
        tableView = new TableView(conn);
    }

    /**
     * f[^x[XEIuWFNg̃XgԂB
     */
    public Vector getObjectList() {
        return objectList;
    }

    /**
     * LoX̃obNOEhEJ[ύXAhׂB
     * @param backgroung VobNOEhEJ[B
     */
    public void setCanvasBackground(Color background) {
        objectCanvas.setCanvasBackground(background);
    }

    /**
     * ANeBu/ANeBuB TableView oĂA
     * ANeBu/ANeBuB
     * @param f tO
     */
    public synchronized void setEnabled(boolean f) {
        super.setEnabled(f);
        if (tableView != null)
            tableView.setEnabled(f);
    }

    /**
     * LoXŔ mouse clicked Cxg̃nhOB
     * @param ev CxgB
     */
    public void mouseClicked(MouseEvent ev) {
        TableObject to = (TableObject)objectCanvas.selectedObject();
        hideTableView();
        if (to != null && ev.getClickCount() == 2) {
            tableView.showTable(to.getName());
        } 
    }

    /**
     * LoXŔ mouse pressed Cxg̃nhOB
     * ۂ͉ȂB
     * @param ev CxgB
     */
    public void mousePressed(MouseEvent ev) {}

    /**
     * LoXŔ mouse released Cxg̃nhOB
     * ۂ͉ȂB
     * @param ev CxgB
     */
    public void mouseReleased(MouseEvent ev) {}

    /**
     * LoXŔ mouse entered Cxg̃nhOB
     * ۂ͉ȂB
     * @param ev CxgB
     */
    public void mouseEntered(MouseEvent ev) {}

    /**
     * LoXŔ mouse exited Cxg̃nhOB
     * ۂ͉ȂB
     * @param ev CxgB
     */
    public void mouseExited(MouseEvent ev) {}

    /**
     * ZNVŔ action performed Cxg̃nhOB
     * @param ev CxgB
     */
    public void actionPerformed(ActionEvent ev) {
        String[] ts;
        int selIx;
        selIx = objectTypeSelection.getFirstSelectedIndex();
        switch(selIx) {
        case 0: // user table
            ts = new String[1];
            ts[0] = "TABLE";
            generateTableObjectList(ts);
            break;
        case  1: // system table
            ts = new String[1];
            ts[0] = "SYSTEM TABLE";
            generateTableObjectList(ts);
            break;
        case  -1:
            objectList = null;
            break;
        default:
            break;
        }
        hideTableView();
        objectCanvas.setObjectList(objectList);
        repaint();
    }

    /**
     * f[^x[XEe[uEIuWFNg̃Xg𐶐B
     * @param types f[^x[Xɂe[uE^Cv\킷
     * zB
     */
    protected void generateTableObjectList(String[] types) {
        DatabaseMetaData dmd;
        ResultSet tables;
        Vector ol = new Vector();
        DatabaseObject dbo;
        int tableType;
        int count = 0;
        //
        hideTableView();
        try {
            if (conn == null || conn.isClosed()) {
                setConnection(null);
                return;
            }
            dmd = conn.getMetaData();
            tables = dmd.getTables("", "%", "%", types);
            while(tables.next()) {
                count++;
                if (tables.getString("TABLE_TYPE").equals("TABLE")) 
                    tableType = TableObject.USERTABLE;
                else if (tables.getString("TABLE_TYPE").equals("SYSTEM TABLE"))
                    tableType = TableObject.SYSTEMTABLE;
                else
                    tableType = TableObject.UNDEFINED;
                dbo = new TableObject(tables.getString("TABLE_NAME"),
                                      tableType);
                ol.addElement(dbo);
            }
            if (count == 0)
                ol = null;
        } catch(SQLException ex) {
            ol = null;
            Container c;
            for (c = getParent();
                 c != null && !(c instanceof Frame);
                 c.getParent());
            if (c != null)
                new MessageDialog(ex, (Frame)c);
            return;
        }
        objectList = ol;
    }

    /**
     * TableView nChB
     */
    void hideTableView() {
        if (tableView != null) {
            tableView.hide();
        }
    }
}
