/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;

/**
 * JDBCTerminal IN p[^ݒ_CAO
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */
public class InParamDialog extends Dialog implements ActionListener, WindowListener {

    StatementFrame module;

    Label indexLabel;
    TextField indexField;
    Label valueLabel;
    TextField valueField;
    Label setTypeLabel;
    Choice setTypeChoice;
    Button okButton;
    Button cancelButton;

    /**
     * RXgN^
     */
    public InParamDialog(Frame parent, StatementFrame module) {
        super(parent);
        this.module = module;

        addWindowListener(this);
        setTitle("JDBCTerminal: Set IN Parameter");
        
	GridBagLayout gbl = new GridBagLayout();
	gbl.columnWidths = new int[] {14,14,14,14};
	gbl.rowHeights =  new int[] {14,14,14,14,14,14,14,14,14};
	gbl.columnWeights = new double[] {0.0,0.0,0.0,0.0};
	gbl.rowWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	setLayout(gbl);
	GridBagConstraints gbc = new GridBagConstraints();

        //
        indexLabel = new Label("Index:");
        gbc.gridx = 1;
        gbc.gridy = 1;
        gbc.anchor = GridBagConstraints.EAST;
        gbl.setConstraints(indexLabel, gbc);
        add(indexLabel);

        //
        indexField = new TextField(2);
        gbc.gridx++;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(indexField, gbc);
        add(indexField);
        
        //
        valueLabel = new Label("Value:");
        gbc.gridx = 1;
        gbc.gridy += 2;
        gbc.anchor = GridBagConstraints.EAST;
        gbl.setConstraints(valueLabel, gbc);
        add(valueLabel);

        //
        valueField = new TextField(20);
        gbc.gridx++;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(valueField, gbc);
        add(valueField);
        
        //
        setTypeLabel = new Label("set");
        gbc.gridx = 1;
        gbc.gridy += 2;
        gbc.anchor = GridBagConstraints.EAST;
        gbl.setConstraints(setTypeLabel, gbc);
        add(setTypeLabel);
        
        //
        setTypeChoice = new Choice();
        gbc.gridx++;
        gbc.anchor = GridBagConstraints.WEST;
        gbl.setConstraints(setTypeChoice, gbc);
        setTypeChoice.add("Boolean");
        setTypeChoice.add("Byte");
        setTypeChoice.add("Date");
        setTypeChoice.add("Double");
        setTypeChoice.add("Float");
        setTypeChoice.add("Int");
        setTypeChoice.add("Long");
        setTypeChoice.add("Short");
        setTypeChoice.add("String");
        setTypeChoice.add("Time");
        setTypeChoice.add("Timestamp");
        setTypeChoice.add("Null");
        setTypeChoice.select("String");
        add(setTypeChoice);

        //
        okButton = new Button("OK");
        gbc.gridx = 1;
        gbc.gridy += 2;
        gbc.anchor = GridBagConstraints.CENTER;
        gbl.setConstraints(okButton, gbc);
        add(okButton);
        okButton.addActionListener(this);

        //
        cancelButton = new Button("Cancel");
        gbc.gridx++;
        gbl.setConstraints(cancelButton, gbc);
        add(cancelButton);
        cancelButton.addActionListener(this);

        pack();

    }

    /**
     * ANVECxgB
     * @param ev ANVECxg
     */
    public void actionPerformed(ActionEvent ev){
        if (okButton == ev.getSource()) {
	    module.addInParam(indexField.getText(), valueField.getText(), setTypeChoice.getSelectedItem());
	}
        setVisible(false);
    }

    /**
     * _CAOB
     * @param ev EBhEECxg
     */
    public void windowClosing(WindowEvent ev){
        setVisible(false);
    }

    public void windowClosed(WindowEvent ev) {}
    public void windowDeiconified(WindowEvent ev) {}
    public void windowIconified(WindowEvent ev) {}
    public void windowOpened(WindowEvent ev) {}


}
