/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import COM.Sun.Japan.yjs.mwt.*;

/**
 * JDBCTerminal CEt[ GUI
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */
public class MainFrameGUI extends Frame {

    MainFrame mainFrame;
    Label URLLabel;
    TextField URLTextField;
    Button connectButton;
    Label driverLabel;
    List driverList;
    Label driverChoiceTypeLabel;

    Panel driverChoiceTypePanel;
    CheckboxGroup driverChoiceTypeCheckboxGroup;
    Checkbox selectedDriverCheckbox;
    Checkbox driverManagerCheckbox;

    Button registerDriverButton;
    Button deregisterDriverButton;

    MenuBar MainMenuBar;
    Menu FileMenu;
    Menu WindowMenu;
    MenuItem FileMenuQuit;
    MenuItem WindowMenuStatement;
    MenuItem WindowMenuLog;

    public MainFrameGUI(MainFrame mainFrame) {
	this.mainFrame = mainFrame;
	setTitle("JDBCTerminal");

	GridBagLayout gbl = new GridBagLayout();
	gbl.columnWidths = new int[] {14,14,14,14,14,14,14};
	gbl.rowHeights =  new int[] {14,14,14,14,14,14,14,14};
	gbl.columnWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	gbl.rowWeights = new double[] {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
	setLayout(gbl);
	GridBagConstraints gbc = new GridBagConstraints();

	// 
	URLLabel = new Label("JDBC URL:");
	gbc.gridx = 1;
	gbc.gridy = 1;
	gbc.anchor = GridBagConstraints.WEST;
	gbl.setConstraints(URLLabel, gbc);
	add(URLLabel);

	// Create URL TextField
	URLTextField = new TextField(35);
	gbc.gridy = 2;
	gbl.setConstraints(URLTextField, gbc);
	add(URLTextField);

	// Create driverLabel
	driverLabel = new Label("Loaded Drivers:");
	gbc.gridy = 4;
	gbl.setConstraints(driverLabel, gbc);
	add(driverLabel);

	// Create driver list
	driverList = new List(5);
	gbc.gridy = 5;
	gbc.fill = GridBagConstraints.BOTH;
	gbl.setConstraints(driverList, gbc);
	add(driverList);
	
	// create Connect Button
	connectButton = new Button("Connect...");
	gbc.gridx = 3;
	gbc.gridy = 2;
	gbc.gridwidth = 3;
	gbc.fill = GridBagConstraints.NONE;
	gbl.setConstraints(connectButton, gbc);
	connectButton.addActionListener(new MainFrameCommand(MainFrameCommand.Connect, mainFrame));
	add(connectButton);

	//
	driverChoiceTypeLabel = new Label("Driver Selection:");
        gbc.gridy = 4;
	gbl.setConstraints(driverChoiceTypeLabel, gbc);
	add(driverChoiceTypeLabel);

	// driverChoicePanel
	driverChoiceTypePanel = new Panel();
	GridBagLayout dctpGbl = new GridBagLayout();
	dctpGbl.columnWidths = new int[] {14};
	dctpGbl.rowHeights =  new int[] {14,14};
	dctpGbl.columnWeights = new double[] {0.0};
	dctpGbl.rowWeights = new double[] {0.0,0.0,0.0,0.0};
	driverChoiceTypePanel.setLayout(dctpGbl);

	GridBagConstraints dctpGbc = new GridBagConstraints();

	driverChoiceTypeCheckboxGroup = new CheckboxGroup();
	driverManagerCheckbox = new Checkbox("Use Driver Manager", true, driverChoiceTypeCheckboxGroup);
	dctpGbc.anchor = GridBagConstraints.WEST;
	dctpGbl.setConstraints(driverManagerCheckbox, dctpGbc);
	driverChoiceTypePanel.add(driverManagerCheckbox);

	selectedDriverCheckbox = new Checkbox("Selected Driver", false, driverChoiceTypeCheckboxGroup);
	dctpGbc.gridy = 1;
	dctpGbl.setConstraints(selectedDriverCheckbox, dctpGbc);
	driverChoiceTypePanel.add(selectedDriverCheckbox);

	gbc.gridy = 5;
	gbc.anchor = GridBagConstraints.NORTHWEST;
	gbl.setConstraints(driverChoiceTypePanel, gbc);
	add(driverChoiceTypePanel);

	// add Two Buttons
	registerDriverButton = new Button("Add Driver...");
	gbc.gridy = 6;
	gbc.gridwidth = 1;
	gbc.anchor = GridBagConstraints.WEST;
	gbl.setConstraints(registerDriverButton, gbc);
	registerDriverButton.addActionListener(new MainFrameCommand(MainFrameCommand.RegisterDriver, mainFrame));
	add(registerDriverButton);

	deregisterDriverButton = new Button("Delete Driver");
	gbc.gridx = 5;
	gbl.setConstraints(deregisterDriverButton, gbc);
	deregisterDriverButton.addActionListener(new MainFrameCommand(MainFrameCommand.DeregisterDriver, mainFrame));
	add(deregisterDriverButton);

	// Add Menus
	MainMenuBar = new MenuBar();
	FileMenu = new Menu("File");
	FileMenuQuit = new MenuItem("Quit");
	FileMenuQuit.addActionListener(new MainFrameCommand(MainFrameCommand.FileMenuQuit, mainFrame));
	FileMenu.add(FileMenuQuit);
	MainMenuBar.add(FileMenu);

	WindowMenu = new Menu("Window");
	WindowMenuStatement = new MenuItem("SQL Statement");
	WindowMenuStatement.addActionListener(new MainFrameCommand(MainFrameCommand.WindowMenuStatement, mainFrame));
	WindowMenu.add(WindowMenuStatement);
	WindowMenuLog = new MenuItem("Error/Warning");
	WindowMenuLog.addActionListener(new MainFrameCommand(MainFrameCommand.WindowMenuLog, mainFrame));
	WindowMenu.add(WindowMenuLog);
	MainMenuBar.add(WindowMenu);

	setMenuBar(MainMenuBar);

	pack();
    }
}
