/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

import java.awt.*;
import java.awt.event.*;

/**
 * JDBCTerminal Xe[ggEt[̃CxgEXi
 * @version	%I% %E%
 * @author 	Yuichi Omata, Nihon Sun Microsystems K.K.
 */
public class StatementFrameCommand implements ActionListener, WindowListener, ItemListener {
    static final int Exec = 1;
    static final int SetIn = 2;
    static final int SetOut = 3;
    static final int ClearIn = 4;
    static final int ClearOut = 5;
    static final int Inspect = 6;

    int id;
    StatementFrame module;
    StatementFrameGUI gui;

    /**
     * GUI ̃Cxg
     * @param id 
     * @param module 
     */
    public StatementFrameCommand(int id, StatementFrame module) {
	this.id = id;
	this.module = module;
    }

    /**
     * ANVECxgB
     * @param ev ANVECxg
     */
    public void actionPerformed(ActionEvent ev){
	switch (id){
	case Exec:
	    module.exec();
	    break;
	case SetIn:
	    module.showInParamDialog();
	    break;
	case SetOut:
	    module.showOutParamDialog();
	    break;
	case ClearIn:
	    module.clearInParam();
	    break;
	case ClearOut:
	    module.clearOutParam();
	    break;
	case Inspect:
	    module.showInspectDialog();
	    break;
	}
    }


    /**
     * GUI ̃EBhEB
     * @param ev EBhEECxg
     */
    public void windowClosing(WindowEvent ev){
//	module.getGUI().setVisible(false);
        module.statementClose();
    }

    public void windowClosed(WindowEvent ev) {}
    public void windowDeiconified(WindowEvent ev) {}
    public void windowIconified(WindowEvent ev) {}
    public void windowOpened(WindowEvent ev) {}

    /**
     * Statement `FbN{bNX̃CxgB
     * @param ev ACeECxg
     */
    public void itemStateChanged(ItemEvent ev) {
        module.statementTypeChanged(ev.getItem().toString());
    }

}
