/*
 * Copyright (c) 1996 by Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

package COM.Sun.Japan.yjs.mwt;

import java.awt.event.*;
import java.util.EventListener;
import java.util.Vector;
import java.util.Enumeration;

/**
 * EventListener ւ̃Cxg̓`莝NXBƂ肠A
 * EventListenerListB
 *
 * @version     1.1 97/01/11
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class EventListenerList implements
ActionListener, AdjustmentListener, ComponentListener,
FocusListener, ItemListener, KeyListener,
MouseListener, MouseMotionListener, WindowListener  {
    /**
     * Cxg` event listener ̃XgB
     */
    protected Vector listenerList;

    /**
     * ftHgERXgN^B
     */
    protected EventListenerList() {
        this(null);
    }

    /**
     * event listener Ɏ RXgN^B
     * @param l event listener
     */
    protected EventListenerList(EventListener l) {
        listenerList = new Vector();
        if (l == null)
            return;
        listenerList.addElement(l);
    }

    /**
     * listener list  event listener ǉB
     * @param l event listener
     */
    protected void addListener(EventListener l) {
        listenerList.addElement(l);
    }

    /**
     * listener ǉB EventListenerList ̏ꍇ̂݋@\
     * B
     * @param l1 event listener (EventListenerList)
     * @param l2 event listener
     */
    protected static EventListener addListener(EventListener l1, EventListener l2) {
        if (l1==null)
            return l2;
        if (l2==null)
            return l1;
        if (l1 instanceof EventListenerList) {
            ((EventListenerList)l1).addListener(l2);
            return l1;
        }
        EventListenerList ell = new EventListenerList(l1);
        ell.addListener(l2);
        return ell;
    }

    /**
     * o^Ă listener list  listener OB
     * @param l event listener
     */
    protected void removeListener(EventListener l) {
        listenerList.removeElement(l);
    }

    /**
     * listener OB EventListenerList ̏ꍇ̂݁A@\B
     * @param l1 event listener(EventListenerList)
     * @param l2 event listener
     */
    protected static EventListener removeListener(EventListener l1, EventListener l2) {
        if (l1==null || l1==l2)
            return null;
        if (l1 instanceof EventListenerList) {
            ((EventListenerList)l1).removeListener(l2);
            return l1;
        }
        return l1;
    }

    /**
     * listner ̒ǉB
     * @param l1 action event listener
     * @param l2 action event listener
     */
    public static ActionListener add(ActionListener l1, ActionListener l2) {
        return (ActionListener)addListener(l1, l2);
    }

    /**
     * lisner ̒ǉB
     * @param l1 adjustment event listener
     * @param l2 adjustment event listener
     */
    public static AdjustmentListener add(AdjustmentListener l1, AdjustmentListener l2) {
        return (AdjustmentListener)addListener(l1, l2);
    }

    /**
     * lisner ̒ǉB
     * @param l1 component event listener
     * @param l2 component event listener
     */
    public static ComponentListener add(ComponentListener l1, ComponentListener l2) {
        return (ComponentListener)addListener(l1, l2);
    }

    /**
     * lisner ̒ǉB
     * @param l1 focus event listener
     * @param l2 focus event listener
     */
    public static FocusListener add(FocusListener l1, FocusListener l2) {
        return (FocusListener)addListener(l1, l2);
    }

    /**
     * lisner ̒ǉB
     * @param l1 item event listener
     * @param l2 item event listener
     */
    public static ItemListener add(ItemListener l1, ItemListener l2) {
        return (ItemListener)addListener(l1, l2);
    }

    /**
     * lisner ̒ǉB
     * @param l1 key event listener
     * @param l2 key event listener
     */
    public static KeyListener add(KeyListener l1, KeyListener l2) {
        return (KeyListener)addListener(l1, l2);
    }

    /**
     * lisner ̒ǉB
     * @param l1 mouse event listener
     * @param l2 mouse event listener
     */
    public static MouseListener add(MouseListener l1, MouseListener l2) {
        return (MouseListener)addListener(l1, l2);
    }

    /**
     * lisner ̒ǉB
     * @param l1 mouse motion event listener
     * @param l2 mouse motion event listener
     */
    public static MouseMotionListener add(MouseMotionListener l1, MouseMotionListener l2) {
        return (MouseMotionListener)addListener(l1, l2);
    }

    /**
     * lisner ̒ǉB
     * @param l1 window event listener
     * @param l2 window event listener
     */
    public static WindowListener add(WindowListener l1, WindowListener l2) {
        return (WindowListener)addListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 action event listener
     * @param l2 action event listener
     */
    public static ActionListener remove(ActionListener l1, ActionListener l2) {
        return (ActionListener)removeListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 adjustment event listener
     * @param l2 adjustment event listener
     */
    public static AdjustmentListener remove(AdjustmentListener l1, AdjustmentListener l2) {
        return (AdjustmentListener)removeListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 component event listener
     * @param l2 component event listener
     */
    public static ComponentListener remove(ComponentListener l1, ComponentListener l2) {
        return (ComponentListener)removeListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 focus event listener
     * @param l2 focus event listener
     */
    public static FocusListener remove(FocusListener l1, FocusListener l2) {
        return (FocusListener)removeListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 item event listener
     * @param l2 item event lisetner
     */
    public static ItemListener remove(ItemListener l1, ItemListener l2) {
        return (ItemListener)removeListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 key event listener
     * @param l2 key event lisetner
     */
    public static KeyListener remove(KeyListener l1, KeyListener l2) {
        return (KeyListener)removeListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 mouse event listener
     * @param l2 mouse event lisetner
     */
    public static MouseListener remove(MouseListener l1, MouseListener l2) {
        return (MouseListener)removeListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 mouse motion event listener
     * @param l2 mouse motion event lisetner
     */
    public static MouseMotionListener remove(MouseMotionListener l1, MouseMotionListener l2) {
        return (MouseMotionListener)removeListener(l1, l2);
    }

    /**
     * listener ̍폜B
     * @param l1 window event listener
     * @param l2 window event lisetner
     */
    public static WindowListener remove(WindowListener l1, WindowListener l2) {
        return (WindowListener)removeListener(l1, l2);
    }

    /**
     * action performed Cxg̃nhOB
     */
    public void actionPerformed(ActionEvent ev) {
        Enumeration ls;
        for(ls=listenerList.elements(); ls.hasMoreElements();) {
            ((ActionListener)(ls.nextElement())).actionPerformed(ev);
         }
    }

    /**
     * adjustment value changed Cxg̃nhOB
     */
    public void adjustmentValueChanged(AdjustmentEvent ev) {
        Enumeration ls;
        for(ls=listenerList.elements(); ls.hasMoreElements();) {
            ((AdjustmentListener)(ls.nextElement())).adjustmentValueChanged(ev);
        }
    }

    /**
     * componet resized Cxg̃nhOB
     */
    public void componentResized(ComponentEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((ComponentListener)(ls.nextElement())).componentResized(ev);
        }
    }

    /**
     * component moved Cxg̃nhOB
     */
    public void componentMoved(ComponentEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((ComponentListener)(ls.nextElement())).componentMoved(ev);
        }
    }

    /**
     * component shown Cxg̃nhOB
     */
    public void componentShown(ComponentEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((ComponentListener)(ls.nextElement())).componentShown(ev);
        }
    }

    /**
     * component hidden Cxg̃nhOB
     */
    public void componentHidden(ComponentEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((ComponentListener)(ls.nextElement())).componentHidden(ev);
        }
    }

    /**
     * focus gained Cxg̃nhOB
     */
    public void focusGained(FocusEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((FocusListener)(ls.nextElement())).focusGained(ev);
        }
    }

    /**
     * focus lost Cxg̃nhOB
     */
    public void focusLost(FocusEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((FocusListener)(ls.nextElement())).focusLost(ev);
        }
    }

    /**
     * item state changed Cxg̃nhOB
     */
    public void itemStateChanged(ItemEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((ItemListener)(ls.nextElement())).itemStateChanged(ev);
        }
    }

    /**
     * key typed Cxg̃nhOB
     */
    public void keyTyped(KeyEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((KeyListener)(ls.nextElement())).keyTyped(ev);
        }
    }

    /**
     * key pressed Cxg̃nhOB
     */
    public void keyPressed(KeyEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((KeyListener)(ls.nextElement())).keyPressed(ev);
        }
    }

    /**
     * key released Cxg̃nhOB
     */
    public void keyReleased(KeyEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((KeyListener)(ls.nextElement())).keyReleased(ev);
        }
    }

    /**
     * mouse clicked Cxg̃nhOB
     */
    public void mouseClicked(MouseEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((MouseListener)(ls.nextElement())).mouseClicked(ev);
        }
    }

    /**
     * mouse pressed Cxg̃nhOB
     */
    public void mousePressed(MouseEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((MouseListener)(ls.nextElement())).mousePressed(ev);
        }
    }

    /**
     * mouse released Cxg̃nhOB
     */
    public void mouseReleased(MouseEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((MouseListener)(ls.nextElement())).mouseReleased(ev);
        }
    }

    /**
     * mouse entered Cxg̃nhOB
     */
    public void mouseEntered(MouseEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((MouseListener)(ls.nextElement())).mouseEntered(ev);
        }
    }
    
    /**
     * mouse exited Cxg̃nhOB
     */
    public void mouseExited(MouseEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((MouseListener)(ls.nextElement())).mouseExited(ev);
        }
    }

    /**
     * mouse dragged Cxg̃nhOB
     */
    public void mouseDragged(MouseEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((MouseMotionListener)(ls.nextElement())).mouseDragged(ev);
        }
    }

    /**
     * mouse moved Cxg̃nhOB
     */
    public void mouseMoved(MouseEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((MouseMotionListener)(ls.nextElement())).mouseMoved(ev);
        }
    }

    /**
     * window opened Cxg̃nhOB
     */
    public void windowOpened(WindowEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((WindowListener)(ls.nextElement())).windowOpened(ev);
        }
    }

    /**
     * window closing Cxg̃nhOB
     */
    public void windowClosing(WindowEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((WindowListener)(ls.nextElement())).windowClosing(ev);
        }
    }

    /**
     * window closed Cxg̃nhOB
     */
    public void windowClosed(WindowEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((WindowListener)(ls.nextElement())).windowClosed(ev);
        }
    }

    /**
     * window iconified Cxg̃nhOB
     */
    public void windowIconified(WindowEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((WindowListener)(ls.nextElement())).windowIconified(ev);
        }
    }

    /**
     * window deiconified Cxg̃nhOB
     */
    public void windowDeiconified(WindowEvent ev) {
        Enumeration ls;
        for (ls=listenerList.elements(); ls.hasMoreElements();) {
            ((WindowListener)(ls.nextElement())).windowDeiconified(ev);
        }
    }
}
