/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

package COM.Sun.Japan.yjs.mwt;

import java.awt.*;

/**
 * xt̃R|[lgB
 * ̂ƂȂR|[lgɕt郉ẍʒuwłB
 * wł郉ẍʒúA"ON_LEFT", "ON_CENTER","ON_RIGHT","LEFT","RIGHT"
 * łBʒuw肵Ȃꍇ̃ftHg "ON_LEFT"B
 * <pre>
 * 
 * label                label                label
 * +-----------+    +-----------+    +-----------+
 * | component |    | component |    | component |
 * +-----------+    +-----------+    +-----------+
 * "ON_LEFT"        "ON_CENTER"      "ON_RIGHT"
 *
 *       +-----------+          +-----------+   
 * label | component |          | component | label
 *       +-----------+          +-----------+
 *    "LEFT"                           "RIGHT"
 *
 * </pre>
 *
 * @version	%I% %E%
 * @author 	 T
 */
public class LabeledComponent extends Panel {

    /**
     * R|[lgɕt郉xB
     */
    Label label;    

    /**
     * xt郁CER|[lgB
     */
    Component comp;

    /**
     * ̃x𐶐R|[lgƌтB
     * @param comp xtR|[lg
     */
    public LabeledComponent(Component comp) {
	this(comp, "", "ON_LEFT");
    }

    /**
     * w肳ꂽ񂩂烉x𐶐R|[lgƌтB
     * @param comp xtR|[lg
     * @param text x̕
     */
    public LabeledComponent(Component comp, String text) {
        this(comp, text, "ON_LEFT");
    }

    /**
     * w肵xR|[lg̎w肵ʒuɌтB
     * @param comp xtR|[lg
     * @param text x\镶
     * @param alignment x̔zuꏊ
     */
    public LabeledComponent(Component comp, String text, String alignment) {
	this(comp, new Label(text), alignment);
    }

    /**
     * xR|[lg̎w肵ʒuɌтB
     * @param comp xtR|[lg
     * @param label R|[lgɕt郉x
     * @param alignment x̔zuꏊ
     */
    public LabeledComponent(Component comp, Label label, String alignment) {

	this.label = label;
	this.comp = comp;

	GridBagLayout gbl = new GridBagLayout();
	GridBagConstraints gbc = new GridBagConstraints();

	setLayout(gbl);

	if (alignment.startsWith("ON")){
	    gbc.gridwidth = GridBagConstraints.REMAINDER;
	    if ("ON_LEFT".equals(alignment))
		gbc.anchor = GridBagConstraints.SOUTHWEST;
	    else if ("ON_CENTER".equals(alignment))
		gbc.anchor = GridBagConstraints.SOUTH;
	    else if ("ON_RIGHT".equals(alignment))
		gbc.anchor = GridBagConstraints.SOUTHEAST;
            else
		throw new IllegalArgumentException("improper alignment: " + alignment);

	    gbl.setConstraints(label, gbc);
	    add(label);

	    if ("ON_LEFT".equals(alignment))
		gbc.anchor = GridBagConstraints.NORTHWEST;
	    else if ("ON_CENTER".equals(alignment))
		gbc.anchor = GridBagConstraints.NORTH;
	    else if ("ON_RIGHT".equals(alignment))
		gbc.anchor = GridBagConstraints.NORTHEAST;

	    gbc.weightx = 1.0;
	    gbc.weighty = 1.0;
            gbc.fill = GridBagConstraints.HORIZONTAL;
	    gbl.setConstraints(comp, gbc);
	    add(comp);
	    return;
	} else {
	  gbc.gridwidth = GridBagConstraints.RELATIVE;
	  gbc.anchor = GridBagConstraints.WEST;
	  if ("LEFT".equals(alignment)){
	    gbl.setConstraints(label, gbc);
	    add(label);
	  } else if ("RIGHT".equals(alignment)){
	    gbl.setConstraints(comp, gbc);
	    add(comp);
	  } else
	    throw new IllegalArgumentException("improper alignment: " + alignment);
	  gbc.gridwidth = GridBagConstraints.REMAINDER;
	  if ("LEFT".equals(alignment)){
	    gbl.setConstraints(comp, gbc);
	    add(comp);
	  } else if ("RIGHT".equals(alignment)){
	    gbl.setConstraints(label, gbc);
	    add(label);
	  }
	  return;
	}
    }

    /**
     * x擾B
     */
    public Label getLabel() {
	return label;
    }

    /**
     * R|[lg擾B
     */
    public Component getComponent() {
	return comp;
    }

}
