/*
 * Copyright (c) 1996 by Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

package COM.Sun.Japan.yjs.mwt;

import  java.awt.*;
import  java.awt.event.ActionListener;
import  java.awt.event.ActionEvent;

/**
 * bZ[WG[̏o͂ɗp_CAOB
 *
 * @version     %I% %E%
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class MessageDialog extends Dialog implements ActionListener {
    /**
     * "OK" {^B
     */
    Button ok;

    /**
     * bZ[WƐet[ɎRXgN^B
     * @param mes bZ[WB
     * @param pr et[B
     */
    public MessageDialog(String mes, Frame pr) {
        this(mes, null, "*** Message ***", pr);
    }

    /**
     * GNZvVƐet[ɎRXgN^B
     * @param ex GNZvVB
     * @param pr et[B
     */
    public MessageDialog(Exception ex, Frame pr) {
        this(null, ex, "*** Exception ***", pr);
    }

    /**
     * bZ[WƃGNZvVAet[ɎRXgN^B
     * @param mes bZ[WB
     * @param ex GNZvVB
     * @param pr et[B
     */
    public MessageDialog(String mes, Exception ex, Frame pr) {
        this(mes, ex, "*** Exception ***", pr);
    }

    /**
     * bZ[WƃGNZvVA^CgAet[ɎR
     * XgN^B
     * @param mes bZ[WB
     * @param ex GNZvVB
     * @param tit ^CgB
     * @param pr et[B
     */
    public MessageDialog(String mes, Exception ex, String tit, Frame pr) {
        super(pr, tit, true);
        //
        GridBagLayout gbl = new GridBagLayout();
        GridBagConstraints gbc = new GridBagConstraints();
        String exMes;
        Label lbl;
        setFont(new Font("Helvetica", Font.PLAIN, 14));
        setLayout(gbl);
        ok = new Button("OK");
        gbc.weightx = 0.0;
        gbc.weighty = 0.0;
        gbc.gridwidth = GridBagConstraints.REMAINDER;
        gbc.anchor = GridBagConstraints.CENTER;
        if (tit != null && tit.length() > 0) {
            lbl = new Label(tit);
            gbl.setConstraints(lbl, gbc);
            add(lbl);
        }
        if (mes != null && mes.length() > 0) {
            lbl = new Label(mes);
            gbl.setConstraints(lbl, gbc);
            add(lbl);
        }
        if (ex != null && (exMes = ex.getMessage()) != null && exMes.length() > 0) {
            lbl = new Label(exMes);
            gbl.setConstraints(lbl, gbc);
            add(lbl);
            LogTextArea lta = new LogTextArea("", 8, 40);
            lta.setEditable(false);
            lta.setFont(new Font("Helvetica", Font.PLAIN, 12));
            gbc.weightx = 1.0;
            gbc.weighty = 1.0;
            gbc.fill = GridBagConstraints.BOTH;
            gbl.setConstraints(lta, gbc);
            add(lta);
            try {
                ex.printStackTrace(lta.getLogStream());
            } catch(java.io.IOException iex) {
                // ignore
            }
            gbc.weightx = 0.0;
            gbc.weighty = 0.0;
            gbc.fill = GridBagConstraints.NONE;
        }
        gbl.setConstraints(ok, gbc);
        add(ok);
        //
        pack();
        Dimension d = getSize();
        setSize(Math.min(d.width, 800), Math.min(d.height, 600));
        //
        ok.addActionListener(this);
        setVisible(true);
    }

    /**
     * ok {^Ŕ action performed Cxg̃nhOB
     * @param ev CxgB
     */
    public void actionPerformed(ActionEvent ev) {
        dispose();
    }
}
