/*
 * Copyright (c) 1996 Nihon Sun Microsystems K.K.
 *
 * Permission to use, copy, and distribute this software for
 * NON-COMMERCIAL purposes and without fee is hereby granted
 * provided that this copyright notice appears in all copies.
 *
 */

package COM.Sun.Japan.yjs.mwt;

import java.awt.*;
import java.awt.event.*;

/**
 * Selection ͑I\ȃ{^(SwitchButton)QȂ GUIBIA
 * rI̐؂ւ\B
 *
 * @version     1.4 97/01/09
 * @author      Tadayoshi Maekawa, Nihon Sun Microsystems K.K.
 */
public class Selection extends Panel implements ActionListener {
    /**
     * {^QzuB
     */
    public static final int HORIZONTAL = 1;
    public static final int VERTICAL   = 2;

    /**
     * {^̐B
     */
    int nButtons;
    
    /**
     * Selection ɑ΂郉xB
     * @see #setLabel
     * @see #getLabel
     */
    Label label;

    /**
     * {^̔zB
     * @see #setButtons
     */
    SwitchButton buttons[];
    
    /**
     * Selection Ŝ̕
     * @see #height
     */
    int width;

    /**
     * Selection Ŝ̍
     * @see #width
     */
    int height;

    /**
     * {^zuB
     * @see #HORIZINTAL
     * @see #VERTICAL
     */
    int orient;

    /**
     * /s̃tO
     */
    boolean operatable;

    /**
     * Ỉۂ\킷tO
     * @see #setChoiceOne
     */
    boolean multiselectable;

    /**
     * IĂ{^\킷CfbNXB
     * @see #getFirstSelectedIndex
     * @see #getNextSelectedIndex
     */
    int selectedIndex;

    /**
     * {^Q𒣂tplB
     */
    Panel buttonPanel;

    /**
     * tHg
     */
    Font font;

    /**
     * action listener ܂ action listener ̃Xg(EventListenerList)B
     */
    protected ActionListener actionListener;

    /**
     * ftHgERXgN^B
     */
    public Selection() {
        this("", null, HORIZONTAL);
    }
    
    /**
     * Selection ̃xƃ{^Q̃xɎRXgN^B
     * @param label Selection ̃x
     * @param buttonLabels {^Q̃x̔z
     */
    public Selection(String label, String buttonLabels[]) {
        this(label, buttonLabels, HORIZONTAL);
    }

    /**
     * Constructs a new Selection with a label of this selection,
     * button labels, and a layout diretion.
     * Selection ̃xA{^Q̃xAzu̕Ɏ
     * RXgN^B
     * @param label Selection ̃x
     * @param buttonLabels {^Q̃x̔z
     * @param direction zu̕
     */
    public Selection(String label, String buttonLabels[], int direction) {
        orient = direction;
        multiselectable = false;
        operatable = true;
        selectedIndex = -1;
        width = 0;
        height = 0;
        buttonPanel = new Panel();
        setLayout(new BorderLayout());
        setLabel(label);
        setButtons(buttonLabels);
    }

    /**
     * Selection ̊O쐬B
     */
    public synchronized void addNotify() {
        arrangeButtons();
        makeSelection();
        super.addNotify();
    }

    /**
     * Selection `悷B
     * @param g `Ɏgp Graphics
     */
    public void paint(Graphics g) {
    }
    
    /**
     * Selection ̃x̃ZbgB
     * @param label VSelection ̃xB
     * @see #getLabel
     */
    public void setLabel(String label) {
        if (this.label == null)
            this.label = new Label();
        this.label.setText((label == null) ? "" : label);
    }
    
    /**
     * Selection ̃xԂB
     * @see #setLabel
     */
    public String getLabel() {
        return label.getText();
    }
    
    /**
     * Selection ̃{^QZbgB
     * @param buttonLabels {^Q̃x
     */
    public synchronized void setButtons(String buttonLabels[]) {
        // {^Ex͂邩
        if (buttonLabels == null || buttonLabels.length < 1 ) {
            nButtons = 0;
            buttons = null;
            return;
        }
        // V{^Q(SwitchButton)𐶐
        nButtons = buttonLabels.length;
        buttons = new SwitchButton[nButtons];
        for (int i = 0; i < nButtons; i++) {
            if (buttonLabels[i] == null)
                buttonLabels[i] = "";
            buttons[i] = new SwitchButton(buttonLabels[i]);
            buttons[i].addActionListener(this);
        }
        makeSelection();
    }
    
    /**
     * CfbNXŎw肳ꂽ{^̃xB
     * @param index {^̃CfbNXBindex=0,1, ...
     */
    public String getButtonLabel(int index) {
        return (index >= nButtons || index < 0) ? null : buttons[index].getLabel();
    }

    /**
     * {^̐ԂB
     */
    public int getButtonCounts() {
        return nButtons;
    }

    /**
     * ݂̃{^̃TCYԂB
     * @see #resize
     */
    public Dimension getSize() {
        return new Dimension(width, height);
    }

    /**
     * Dimension ɎATCYB
     * @param d V Dimension
     */
    public void setSize(Dimension d) {
        setSize(d.width, d.height);
    }
    
    /**
     * ƕɎATCYB
     * @param width V
     * @param height V
     */
    public synchronized void setSize(int w, int h) {
        super.setSize(w, h);
        doLayout();
    }

    /**
     * IĂ{^̂Aŏ̂̂̃CfbNXԂB
     * @return {^̃CfbNXBIĂȂ
     * ꍇɂ -1B
     * @see getNextSelectedIndex
     */
    public int getFirstSelectedIndex() {
        for (selectedIndex = 0; selectedIndex < nButtons; selectedIndex++) {
            if (buttons[selectedIndex].getStatus())
                break;
        }
        if (selectedIndex >= nButtons)
            selectedIndex = -1;
        return selectedIndex;
    }
    
    /**
     * IĂ{^̂Â̂̃CfbNXԂB
     * @return {^̃CfbNXBȏIĂ{^
     *  -1B
     * @see getFirstSelectedIndex()
     */
    public int getNextSelectedIndex() {
        if (!multiselectable || selectedIndex < 0)
            return -1;
        for (selectedIndex++; selectedIndex < nButtons; selectedIndex++) {
            if (buttons[selectedIndex].getStatus())
                break;
        }
        if (selectedIndex >= nButtons)
            selectedIndex = -1;
        return selectedIndex;
    }

    /**
     * zu̕ZbgB
     * @param d Vzu
     * @see #HORIZONTAL
     * @see #VERTICAL
     * @see #getLayoutDirection
     */
    public synchronized void setLayoutDirection(int d) {
        Rectangle rect = getBounds();
        Component parent = getParent();
        orient = (d == VERTICAL) ? VERTICAL : HORIZONTAL;
        invalidate();
        makeSelection();
        validate();
    }

    /**
     * zu萔ԂB
     * @see #HORIZONTAL
     * @see #VERTICAL
     * @see #setLayoutDirection
     */
    public int getLayoutDirection() {
        return orient;
    }
     
    /**
     * Ỉۂ\킷tOZbgBtrue Ȃ畡IA
     * false ȂrIƂȂB
     * @param f Ỉۂ\킷tO
     * @see #isMultiselectable
     */
    public synchronized void setMultiselect(boolean f) {
        if (multiselectable != f) {
            multiselectable = f;
            for (int i = 0; i < nButtons; i++) {
                buttons[i].setStatus(false);
            }
        }
    }

    /**
     * Ỉۂ\킷tOԂB
     * @see #setMultiselect
     * @return IȂ trueAsȂ false
     */
    public boolean isMultiselectable() {
        return multiselectable;
    }

    /**
     * CfbNXƃtOɎA{^Q̑IԂ؂ւ
     * B
     * @param index {^̃CfbNX
     * @param status I
     * @see #getButtonStatus
     */
    public synchronized void setButtonStatus(int index, boolean status) {
        // should I throw exception ?
        if (index < 0 || index >= nButtons)
            return;
        buttons[index].setStatus(status);
        // exclusive operation
        if (!multiselectable && status) {
            int  j;
            for (j = 0; j < nButtons; j++) {
                if (j == index)
                    continue;
                buttons[j].setStatus(false);
            }
        }
    }

    /**
     * CfbNXɎA{^̑IԂԂB
     * @param index {^̃CfbNX
     * @return IĂ trueAIȂ false
     * @see #setButtonStatus
     */
    public boolean getButtonStatus(int index) {
        // should I throw exception ?
        if (index < 0 || index >= nButtons)
            return false;
        return buttons[index].getStatus();
    }

    /**
     * /s\킷tOԂB
     * @see #setOperatable
     * @return Ȃ trueAsȂ false
     */
    public boolean isOperatable() {
        return operatable;
    }

    /**
     * /s\킷tOZbgB
     * @param f /s\킷tO
     * @see #isOperatable
     */
    public synchronized void setOperatable(boolean f) {
        operatable = f;
        for (int i= 0; i < nButtons; i++) {
            buttons[i].setOperatable(f);
        }
    }

    /**
     * CfbNXɎA{^̑/s̃tOԂB
     * @param index {^̃CfbNX
     * @return IĂ trueAIȂ false
     * @see #setButtonOperatable
     */
    public boolean isButtonOperatable(int index) {
        // should I throw exception ?
        if (index < 0 || index >= nButtons)
            return false;
        return buttons[index].isOperatable();
    }

    /**
     * CfbNXɎA{^̑/s̃tOZbg
     * B
     * @param index {^̃CfbNX
     * @param f {^̑/s̃tO
     * @see #isButtonOperatable
     */
    public synchronized void setButtonOperatable(int index, boolean f) {
        // should I throw exception ?
        if (index < 0 || index >= nButtons)
            return;
        buttons[index].setOperatable(f);
    }

    /**
     * Selection ANeBu/ANeBuɂB
     * @param f tO
     */
    public synchronized void setEnabled(boolean f) {
        super.setEnabled(f);
        label.setEnabled(f);
        for (int i = 0; i < nButtons; i++)
            buttons[i].setEnabled(f);
    }
    
    /**
     * Selection  GUI \B
     */
    protected void makeSelection() {
        int i;
        GridBagLayout layout = new GridBagLayout();
        GridBagConstraints c = new GridBagConstraints();

        buttonPanel = new Panel();

        removeAll();
        buttonPanel.setLayout(layout);
        if (label != null) {
            if (orient == VERTICAL) {
                c.gridwidth = GridBagConstraints.REMAINDER;
                layout.setConstraints(label, c);
            }
            buttonPanel.add(label);
        }
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1.0;
        c.weighty = 1.0;
        if (buttons != null) {
            for (i = 0; i < nButtons-1; i++) {
                if (orient == VERTICAL)
                    c.gridwidth = GridBagConstraints.REMAINDER;
                layout.setConstraints(buttons[i], c);
                buttonPanel.add(buttons[i]);
            }
            c.gridwidth = GridBagConstraints.REMAINDER;
            layout.setConstraints(buttons[i], c);
            buttonPanel.add(buttons[i]);
        }
        add("Center", buttonPanel);
    }

    /**
     * {^(SwitchButton) action performed Cxg̃nhOB
     * @param ev Cxg
     */
    public void actionPerformed(ActionEvent ev) {
        int i, j;
        int actioned = -1;
        selectedIndex = -1;
        // change ev.arg
        for (i =0; i < nButtons; i++) {
            if (buttons[i].getLabel().equals(ev.getActionCommand())) {
                actioned = i;
                break;
            }
        }
        // exclusive operation
        if (i < nButtons && !multiselectable && buttons[i].getStatus()) {
            for (j = 0; j < nButtons; j++) {
                if (j == i)
                    continue;
                buttons[j].setStatus(false);
            }
        }
        processActionEvent(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, String.valueOf(actioned)));
    }

    /**
     *  Selection Ŕ action Cxg󂯂 action listener
     * ǉB
     * @param l action listener
     */
    public void addActionListener(ActionListener l) {
        actionListener = EventListenerList.add(actionListener, l);
        newEventsOnly = true;
    }

    /**
     *  Selection Ŕ action Cxg󂯂Ă action listener
     * OB
     * @param l action listener
     */
    public void removeActionListener(ActionListener l) {
        actionListener = EventListenerList.remove(actionListener, l);
    }

    /**
     * action Cxg̏sB
     * @param ev action Cxg
     */
    protected void processActionEvent(ActionEvent ev) {
        if (!operatable)
            return;
        if (actionListener != null) {
            actionListener.actionPerformed(ev);
        }
    }

    /**
     * Selection \킷ԂB
     */
    protected String paramString() {
        return super.paramString() + ",label=" + label +",nButtons=" + nButtons;
    }

    /**
     * {^̑傫낦悤ATCYvZB
     */
    protected void arrangeButtons() {
        int maxW;
        int i;
        Dimension d;
        FontMetrics fm;
        Font f;

        if (font != null) {
            f = font;
        } else {
            f = getFont();
            if (f == null) {
                Graphics  g = getGraphics();
                f = (g != null) ? (g.getFont()) : null;
            }
        }
 
        if (nButtons < 1)
            return;
        for (i=0, maxW = 0; i < nButtons; i++) {
            buttons[i].fitButton();
            d = buttons[i].getSize();
            maxW = Math.max(maxW, d.width);
        }
        for (i = 0; i < nButtons; i++) {
            d = buttons[i].getSize();
            buttons[i].setSize(maxW, d.height);
        }
        invalidate();
        buttonPanel.validate();
        doLayout();
        validate();
    }
}
